/***************************************************
 *
 * This is the order-n arithmetic coding class
 *
 */
#ifndef _COMPRESSARTH_H
	#define _COMPRESSARTH_H
#ifndef _COMPRESS_H
	#include "compress.h"
#endif
#ifndef _MSTRING_H
	#include "mstring.h"
#endif
#ifndef _INC_STDIO
	#include <stdio.h>
#endif
#ifndef __IOSTREAM_H
	#include <iostream>
#endif
#ifndef __SYMBOL_H
	#include "symbol.h"
#endif


using namespace std;

//some global definitions...
#define END_OF_STREAM 256

class CompressArith	: public Compress {
public:
	CompressArith();
	~CompressArith();
	void	CompressFile( String &input, String &output );
	void	ExpandFile( String &input, String &output );
protected:
	void build_model( bit_file *input, bit_file *output );
	void scale_counts( unsigned long counts[], unsigned char scaled_counts[] );
	void build_totals( unsigned char scaled_counts[] );
	void count_bytes( bit_file *input, unsigned long counts[] );
	void output_counts( bit_file *output, unsigned char scaled_counts[] );
	void input_counts( bit_file *stream );
	void convert_int_to_symbol( int symbol, Symbol *s );
	void get_symbol_scale( Symbol *s );
	int convert_symbol_to_int( int count, Symbol *s );
	void initialize_arithmetic_encoder( void );
	void encode_symbol( bit_file *stream, Symbol *s );
	void flush_arithmetic_encoder( bit_file *stream );
	short int get_current_count( Symbol *s );
	void initialize_arithmetic_decoder( bit_file *stream );
	void remove_symbol_from_stream( bit_file *stream, Symbol *s );

    short int totals[ 258 ];            /* The cumulative totals                */
/*
 * These four variables define the current state of the arithmetic
 * coder/decoder.  They are assumed to be 16 bits long.  Note that
 * by declaring them as short ints, they will actually be 16 bits
 * on most 80X86 and 680X0 machines, as well as VAXen.
 */
    unsigned short int code;  /* The present input code value       */
    unsigned short int low;   /* Start of the current code range    */
    unsigned short int high;  /* End of the current code range      */
    long underflow_bits;      /* Number of underflow bits pending   */

};
#endif