/*
    supporting class originally designed for the compression classes
    does bitwise I/O on files. Modified to use IOSTREAM classes.
*/
#include <iostream> 	//ios
#include <fstream> 	//ofstream
#include "mstring.h"    //string objects
#include "bitfile.h"    //this class

using namespace std;

bit_file::bit_file (BitFileType t, String &FileName) 
    : oFile (NULL), iFile (NULL)  
{
   switch(t)  {
   case Input:
  	 iFile = new ifstream(FileName.c_str(),ios::in | ios::binary);
       break;
   case Output:
  	 oFile = new ofstream(FileName,ios::out | ios::binary);
       break;
   default:
       throw("BitFile::Error! Bad Type");
   }
}
bit_file::~bit_file () 
  {
    if(iFile != NULL)
        delete iFile;
    if(oFile != NULL)
        delete oFile;
  }

int  bit_file::GetBit(void) 
{ 
    char b; 

    iFile->read(&b,1); 
    return b; 
}

int  bit_file::IsEOF(void) 
{ 
     if (oFile != NULL) {
         if(oFile->eof())
             return 1;
         else
             return 0;
     }
     if (iFile != NULL) {
         if(iFile->eof())
             return 1;
         else
             return 0;
     }
     return 1;
}

void bit_file::CloseFile(void)
{
   char r;

   if(oFile != NULL)   {
       r = rack;

       oFile->write(&r,1);
       oFile->close();
       delete oFile;
       oFile = NULL;
   }
   if(iFile != NULL)   {
       iFile->close();
       delete iFile;
       iFile = NULL;
   }
}

long bit_file::Tell()
{
    if(iFile != NULL)
        return iFile->tellg();
    return -1l;
}

long bit_file::Seek(long Pos, SeekDir Ref)
{
    if(iFile != NULL){
        switch(Ref) {
        case Beg:
            iFile->seekg(Pos, ios_base::beg);
            break;
        case Cur:
            iFile->seekg(Pos, ios_base::cur);
            break;
        case End:
            iFile->seekg(Pos, ios_base::end);
            break;
        }
        return Pos;
    }
    return -1l;
}
